# This file was automatically generated by Dist::Zilla::Plugin::MakeMaker v5.043.
use strict;
use warnings;

use 5.010001;

use ExtUtils::MakeMaker;

my %WriteMakefileArgs = (
  "ABSTRACT" => "Some utilities for Org documents",
  "AUTHOR" => "perlancar <perlancar\@cpan.org>",
  "CONFIGURE_REQUIRES" => {
    "ExtUtils::MakeMaker" => 0,
    "Perl::osnames" => "0.09"
  },
  "DISTNAME" => "App-OrgUtils",
  "EXE_FILES" => [
    "bin/count-done-org-todos",
    "bin/count-org-headlines-fast",
    "bin/count-org-todos",
    "bin/count-org-todos-fast",
    "bin/count-undone-org-todos",
    "bin/dump-org-structure",
    "bin/filter-org-by-headlines",
    "bin/list-org-anniversaries",
    "bin/list-org-headlines",
    "bin/list-org-headlines-fast",
    "bin/list-org-priorities",
    "bin/list-org-tags",
    "bin/list-org-todo-states",
    "bin/list-org-todos",
    "bin/list-org-todos-fast",
    "bin/select-org-elements",
    "bin/stat-org-document"
  ],
  "LICENSE" => "perl",
  "MIN_PERL_VERSION" => "5.010001",
  "NAME" => "App::OrgUtils",
  "PREREQ_PM" => {
    "Code::Includable::Tree::NodeMethods" => "0.06",
    "Complete::Util" => "0.26",
    "Cwd" => 0,
    "Data::CSel" => "0.04",
    "DateTime" => 0,
    "Digest::MD5" => 0,
    "Exporter" => 0,
    "Function::Fallback::CoreOrPP" => 0,
    "Getopt::Long::EvenLess" => 0,
    "Lingua::EN::Numbers::Ordinate" => 0,
    "List::MoreUtils" => 0,
    "List::Util" => 0,
    "Log::Any::IfLOG" => "0.07",
    "Org::Dump" => 0,
    "Org::Parser" => "0.46",
    "Perinci::CmdLine::Any" => "0.09",
    "Perinci::Sub::ArgEntity::dirname" => 0,
    "Perinci::Sub::ArgEntity::filename" => 0,
    "Perinci::Sub::ArgEntity::timezone" => 0,
    "Perinci::Sub::Util" => "0.38",
    "Time::HiRes" => 0,
    "experimental" => 0,
    "open" => 0,
    "strict" => 0,
    "warnings" => 0
  },
  "TEST_REQUIRES" => {
    "File::Spec" => 0,
    "IO::Handle" => 0,
    "IPC::Open3" => 0,
    "Test::More" => 0
  },
  "VERSION" => "0.40",
  "test" => {
    "TESTS" => "t/*.t"
  }
);


my %FallbackPrereqs = (
  "Code::Includable::Tree::NodeMethods" => "0.06",
  "Complete::Util" => "0.26",
  "Cwd" => 0,
  "Data::CSel" => "0.04",
  "DateTime" => 0,
  "Digest::MD5" => 0,
  "Exporter" => 0,
  "File::Spec" => 0,
  "Function::Fallback::CoreOrPP" => 0,
  "Getopt::Long::EvenLess" => 0,
  "IO::Handle" => 0,
  "IPC::Open3" => 0,
  "Lingua::EN::Numbers::Ordinate" => 0,
  "List::MoreUtils" => 0,
  "List::Util" => 0,
  "Log::Any::IfLOG" => "0.07",
  "Org::Dump" => 0,
  "Org::Parser" => "0.46",
  "Perinci::CmdLine::Any" => "0.09",
  "Perinci::Sub::ArgEntity::dirname" => 0,
  "Perinci::Sub::ArgEntity::filename" => 0,
  "Perinci::Sub::ArgEntity::timezone" => 0,
  "Perinci::Sub::Util" => "0.38",
  "Test::More" => 0,
  "Time::HiRes" => 0,
  "experimental" => 0,
  "open" => 0,
  "strict" => 0,
  "warnings" => 0
);


unless ( eval { ExtUtils::MakeMaker->VERSION(6.63_03) } ) {
  delete $WriteMakefileArgs{TEST_REQUIRES};
  delete $WriteMakefileArgs{BUILD_REQUIRES};
  $WriteMakefileArgs{PREREQ_PM} = \%FallbackPrereqs;
}

delete $WriteMakefileArgs{CONFIGURE_REQUIRES}
  unless eval { ExtUtils::MakeMaker->VERSION(6.52) };

WriteMakefile(%WriteMakefileArgs);

# modify generated Makefile to generate shell completion scripts. this piece
# is generated by Dist::Zilla::Plugin::GenShellCompletion version 0.10.
GEN_SHELL_COMPLETION:
{
    require Perl::osnames;
    last unless Perl::osnames::is_posix();

    print "Modifying Makefile to generate shell completion on install\n";
    open my($fh), "<", "Makefile" or die "Can't open generated Makefile: $!";
    my $content = do { local $/; ~~<$fh> };

    $content =~ s/^(install :: pure_install doc_install)/$1 comp_install/m
        or die "Can't find pattern in Makefile (1)";

    $content =~ s/^(uninstall :: .+)/$1 comp_uninstall/m
        or die "Can't find pattern in Makefile (2)";

    $content .= qq|\ncomp_install :\n\t| .
        q|$(PERLRUN) -E'if(eval { require App::shcompgen; 1 }) { system "shcompgen", "--verbose", "generate", "--replace", ($$App::shcompgen::VERSION >= 0.15 ? ("--remove"):()), @ARGV }' -- $(EXE_FILES)| .
        qq|\n\n|;

    $content .= qq|\ncomp_uninstall :\n\t| .
        q|$(PERLRUN) -E'if(eval { require App::shcompgen; 1 }) { system "shcompgen", "--verbose", "remove", @ARGV }' -- $(EXE_FILES)| .
        qq|\n\n|;

    open $fh, ">", "Makefile" or die "Can't write modified Makefile: $!";
    print $fh $content;
}
